# Gate

## Build
First build client:
```jshelllanguage
sbt
sbt> go
```

Then launch the lab application server:
```jshelllanguage
project lab // in sbt mode
run /path/to/your/settings/file
```

where your settings file is something like:
```scala
Settings (
    port = 8990,
    MongoDB("opennole", "rocks", "localhost", 27017, "openmole", "login")
)
    //MongoDB(login, pass, host, port, db, dataset)
```

This will use the default MongoDB configuration (mongodb://openmole:rocks@localhost:27017/openmole?login). 
You can launch the jetty server with your own URI:
```jshelllanguage
project server // in sbt mode
run mongodb://myuser:mypassword@myhost:myport/mydb?mycollection
```


You need to have a MongoDB running with the corresponding user declared in the *admin* database (by convention).
To run a mongoDB using docker (you need to forward the port):
```jshelllanguage
docker pull mongo
docker run --name some-mongo -p 27017:27017 -d mongo
```
Then, create the user (openmole by defaut):
```jshelllanguage
mongo
use admin
db.createUser({ user: 'openmole', pwd: 'rocks', roles: ["readWrite"  ] })
use openmole
db.test.save({a:"b"})
```

Then, browse [localhost:8080](localhost:8080)